#ifndef HMC_FACE_H
#define HMC_FACE_H

#include <maya/MVector.h>

struct Vertex;
struct Edge;

struct Face {
   // Basics
   Face(Vertex *_a, Vertex *_b, Vertex *_c);
   Face(const Face& rhs);
   const Face &operator=(const Face &rhs);

   // ModelPart
   void ComputeCost();

   // Instance Functions
   void SetEdge(int idx, Edge *e);
   void RemapEdge(Edge *eOld, Edge *eNew);
   void RemapVertex(Vertex *vOld, Vertex *vNew);
   bool ContainsEdge(Edge *e);

   void Remove(Vertex *v);
   void Verify();
   void Invalidate();

   // Member Data
   bool valid;
   MVector normal;
   bool removed;
   
   union {
      struct {
         Vertex *a, *b, *c;
      };
      struct {
         Vertex *verts[3];
      };
   };

   union {
      struct {
         Edge *x, *y, *z;
      };
      struct {
         Edge *edges[3];
      };
   };

};

#endif