#include <iostream>
#include <maya/MGlobal.h>
#include <maya/MPoint.h>
#include <maya/MVector.h>
#include <maya/MString.h>
#include <maya/MDagPath.h>
#include <maya/MFnDagNode.h>
#include <maya/MSelectionList.h>
#include <maya/MItSelectionList.h>
#include <maya/MItMeshEdge.h>
#include <maya/MFnMesh.h>
#include "MayaParser.h"
#include "QEMMesh.h"

using namespace std;

/* Parse Maya's state here into a mesh format */
QEMMesh* MayaParser::parse(int toCollapse) {
   MStatus stat;
   MSelectionList selected;
   QEMMesh *mesh = new QEMMesh();

   MGlobal::getActiveSelectionList(selected);
   MItSelectionList lItr(selected);

   /* Traverse the DAG to get the shape data */
   MDagPath node;
   MObject comp;
   MFnDagNode nodeFn;
   MFnMesh meshFn;
   int i = 0;

   cout << "Running mesh builder!" << endl;
   for (; !lItr.isDone(); lItr.next()) {
      lItr.getDagPath(node);
      mesh->AddNode(node);

      for (int i = 0; i < toCollapse; i++)
         mesh->CollapseTopEdge();

      mesh->ReplaceMesh(node);
   }
   cout << "Mesh has " << mesh->edges.size() << " edges" << endl;

   cout << "Finished mesh builder!" << endl;

   return mesh;
}