#ifndef HMC_QEMMESH_H
#define HMC_QEMMESH_H
#include <iostream>
#include <vector>
#include <map>
#include <maya/MMatrix.h>
#include <maya/MVector.h>
#include <maya/MObject.h>

#include "Vertex.h"
#include "Edge.h"
#include "Face.h"


struct Edge;

struct QEMMesh {
   QEMMesh();
   void AddNode(MDagPath &node);
   bool CollapseTopEdge();
   void QEMMesh::ReplaceMesh(MDagPath &node);

public:
   
   /* Heapified by cost w/ Edge::edge_ptr_cmp */
   std::vector<Edge *> heap;

   // Master list of components
   std::vector<Vertex *> verts;
   std::vector<Face *> faces;
   std::vector<Edge *> edges;
};

#endif