#ifndef HMC_VERTEX_H
#define HMC_VERTEX_H
#include <maya/MMatrix.h>
#include <maya/MPoint.h>
#include <maya/MVector.h>

#include <vector>

struct Face;
struct Edge;

struct Vertex {
   // Construction
   Vertex();
   Vertex(const MPoint&);

   // Copy
   Vertex(const Vertex &rhs);

   // Op=
   const Vertex &operator=(const Vertex& rhs);

   // ModelPart functions
   void ComputeCost();

   // Instance functions
   void RemapEdge(Edge *eOld, Edge *eNew);
   void RemoveEdge(Edge *e);
   void RemoveFace(Face* f);
   void RemapTo(Vertex * vNew);

   // Member data
   MPoint pos;
   MVector normal;
   std::vector<Face *> faces;
   std::vector<Edge *> edges;
   MMatrix Q;
   bool removed;
};

#endif