#include <iostream>
#include <maya/MSimple.h>
#include <maya/MGlobal.h>
#include <maya/MString.h>
#include <maya/MDagPath.h>
#include <maya/MFnDagNode.h>
#include <maya/MSelectionList.h>

#include "MayaParser.h"
#include "QEMMesh.h"

using namespace std;
DeclareSimpleCommand(qem_simplify, "", "1.0");

/** This is a the entry point into the QEM simplification system.
 * This function will issue dispatches to other functions in the dll bundle
 * to do the heavy lifting.
 */
MStatus qem_simplify::doIt(const MArgList& args) {

   cout << "Initializing hmc_qem" << endl;
   int toCollapse = args.asInt(0);
   if (toCollapse == 0)
      toCollapse = 10;
   cout << "Targetting " << toCollapse << " edges for collapse" << endl;

   /* Create the Face, Edge, Vertex sets */
   cout << "DEBUG: Parsing Mesh from scene" << endl;
   QEMMesh *mesh = MayaParser::parse(toCollapse);
   //mesh->CollapseTopEdge();
   cout << "DEBUG: Finished Parsing Mesh" << endl;

   return MS::kSuccess;
}